diff --git a/gdb/NEWS b/gdb/NEWS
index 58c81203a7e..e21e62a5330 100644
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -918,8 +918,9 @@ show skip-trampoline-functions
   recognize function calls that have been marked as trampolines in the debug
   info.  It improves stepping behavior in that it steps over the trampoline
   code and hides it from the user.  It improves the printing of the stack by
-  hiding trampoline functions from the backtrace.  Currently, only DWARF
-  trampolines are supported.
+  hiding the trampoline frames from the backtrace and skips trampoline
+  functions while returning from the target function of a trampoline call.
+  Currently, only DWARF trampolines are supported.
 
   If this is turned off, GDB will handle @dfn{trampoline functions} the same
   as any other function.
diff --git a/gdb/doc/gdb.texinfo b/gdb/doc/gdb.texinfo
index e737df86988..807cedcd91e 100644
--- a/gdb/doc/gdb.texinfo
+++ b/gdb/doc/gdb.texinfo
@@ -6538,6 +6538,10 @@ DWARF trampolines marked via DW_AT_trampoline are supported by this.
 When issuing a @code{backtrace}, if @code{skip-trampoline-functions} is set,
 @value{GDBN} will skip trampoline frames while printing the stack.
 
+When issuing a @code{finish} or @code{reverse-finish}, if
+@code{skip-trampoline-functions} is set, @value{GDBN} will skip trampoline
+frames while returning from the target function.
+
 Currently, only DWARF trampolines marked via DW_AT_trampoline are supported by
 this.
 
diff --git a/gdb/infcmd.c b/gdb/infcmd.c
index 02f6f0b3683..cf3500398f1 100644
--- a/gdb/infcmd.c
+++ b/gdb/infcmd.c
@@ -1800,6 +1800,18 @@ finish_command (const char *arg, int from_tty)
   if (frame == 0)
     error (_("\"finish\" not meaningful in the outermost frame."));
 
+  if (skip_trampoline_functions)
+    {
+      for (int i = 0; (SAFE_TRAMPOLINE_CHAIN (i, frame)
+		       && in_trampoline_frame (frame)); ++i)
+	frame = get_prev_frame (frame);
+
+      if (frame == nullptr)
+	error (_("\"finish\" not meaningful in the outermost non-trampoline \
+frame.  Consider running \"set skip-trampoline-functions off\", to stop in \
+trampoline frames for the \"finish\" command."));
+    }
+
   clear_proceed_status (0);
 
   tp = inferior_thread ();
diff --git a/gdb/infrun.c b/gdb/infrun.c
index fab98a96ba6..9280cfcc21f 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -8079,6 +8079,14 @@ process_event_stop_test (struct execution_control_state *ecs)
 	  keep_going (ecs);
 	  return;
 	}
+      else if (skip_trampoline_functions && in_trampoline_function (stop_pc))
+	{
+	  /* While reverse stepping if we are in a trampoline function call
+	     we will just continue single step in the hope of leaving the
+	     trampoline again soon.  */
+	  keep_going (ecs);
+	  return;
+	}
     }
 
   /* This always returns the sal for the inner-most frame when we are in a
diff --git a/gdb/infrun.h b/gdb/infrun.h
index fbe88ad4595..3873cca7619 100644
--- a/gdb/infrun.h
+++ b/gdb/infrun.h
@@ -81,6 +81,11 @@ infrun_debug_show_threads (const char *title, ThreadRange threads)
    information.  */
 #define MAX_TRAMPOLINE_CHAIN_SIZE 10
 
+/* True if the trampoline index "i" is less then the maximum allowed size
+   of a trampoline chain.  */
+#define SAFE_TRAMPOLINE_CHAIN(i, frame) \
+  (i < MAX_TRAMPOLINE_CHAIN_SIZE && (frame != nullptr))
+
 /* Nonzero if we want to give control to the user when we're notified
    of shared library events by the dynamic linker.  */
 extern int stop_on_solib_events;
diff --git a/gdb/testsuite/gdb.fortran/func-trampoline.exp b/gdb/testsuite/gdb.fortran/func-trampoline.exp
index bfa0002cf0e..4cb9e4f4919 100644
--- a/gdb/testsuite/gdb.fortran/func-trampoline.exp
+++ b/gdb/testsuite/gdb.fortran/func-trampoline.exp
@@ -13,8 +13,8 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/> .
 
-# Test "backtrace" and "backtrace -n" commands for functions with trampoline
-# calls.
+# Test "backtrace", "backtrace -n" and "finish"  commands for functions with
+# trampoline calls.
 
 require allow_fortran_tests
 
@@ -75,3 +75,12 @@ with_test_prefix "backtrace outerframes" {
 	"#$decimal.* $middle_desc" \
 	"#$decimal.* $outer_desc.*"]
 }
+
+with_test_prefix "finish" {
+    init_test
+
+    gdb_test "finish" [multi_line \
+	"Run till exit from #0 $fill second \\(x=20, y=9\\) $fill" \
+	"${fill}first \\(num1=16, num2=3\\)${fill}" \
+	"${fill}(\r\nValue returned is $valnum_re = 180)"]
+}
diff --git a/gdb/testsuite/gdb.reverse/finish-reverse-trampoline.exp b/gdb/testsuite/gdb.reverse/finish-reverse-trampoline.exp
new file mode 100644
index 00000000000..3a23a30ad0d
--- /dev/null
+++ b/gdb/testsuite/gdb.reverse/finish-reverse-trampoline.exp
@@ -0,0 +1,56 @@
+# Copyright 2024 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test "reverse-finish" command for functions with trampoline.
+
+require supports_reverse allow_fortran_tests
+
+if {![test_compiler_info {ifx-*} f90]} {
+    untested "This test is only applicable for IFX, which emits the\
+	trampoline DIE in Dwarf."
+    return -1
+}
+
+load_lib fortran.exp
+
+set testfile finish-reverse-trampoline
+set srcfile "${srcdir}/gdb.fortran/func-trampoline.f90"
+set binfile [standard_output_file $testfile]
+
+if {[prepare_for_testing "failed to prepare" ${testfile} ${srcfile} \
+    {debug f90}]} {
+    return -1
+}
+
+if {![fortran_runto_main]} {
+    return -1
+}
+
+set inner_loc [gdb_get_line_number "second-breakpt"]
+
+if [supports_process_record] {
+    # Activate process record/replay
+    gdb_test_no_output "record" "turn on process record"
+}
+
+# Set breakpoint inside the innermost function 'second'.
+gdb_breakpoint "$srcfile:$inner_loc"
+gdb_continue_to_breakpoint "innermost-body" ".*$srcfile:$inner_loc.*"
+
+gdb_test "reverse-finish" [multi_line \
+    "Run back to call of #0  second \\(x=20, y=9\\).*" \
+    ".*in first \\(num1=16, num2=3\\).*"]
+
+gdb_test "frame" "#0.*first.*" "Frame 0 shows first function"